import static be.ac.vub.prog.contextj.ContextJ.*;

public class Demo {
  
  public static void main(String[] args) {
    
    final Employer vub = new Employer("Vrije Universiteit Brussel", "1050 Brussel");
    final Person somePerson = new Person("Pascal Costanza", "1000 Brussel", vub);
    
    System.out.println("The following output is context independent.");
    System.out.println(somePerson);
    System.out.println();
    
    System.out.println("The following output includes the address layer.");
    with(Layers.Address).eval(new Block() {
        public void eval() {
          System.out.println(somePerson);
        }
      });
    System.out.println();
    
    System.out.println("The following output includes the address and the employment layers.");
    with(Layers.Address, Layers.Employment).eval(new Block() {
        public void eval() {
          System.out.println(somePerson);
        }
      });
    System.out.println();
    
    System.out.println("Depending on whether arguments were passed to this program, the following output may or may not include the employment layer.");
    with(args.length > 0 ? 
         new Layer[] {Layers.Employment} : 
         new Layer[] {}).eval(new Block() {
             public void eval() {
               System.out.println(somePerson);
             }
           });
    System.out.println();
  }
}
